## vc 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BUILD_DIR)
   message(ERROR "You don't want to configure in the source directory!")
endif()

project(Vc)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(ROOT_RELEASE FALSE CACHE BOOL "Set up for creating a Vc copy inside ROOT/AliRoot.")
mark_as_advanced(ROOT_RELEASE)

set(disabled_targets)

include (VcMacros)
include (AddTargetProperty)
include (OptimizeForArchitecture)

vc_determine_compiler()

if(ROOT_RELEASE)
   file(READ "${CMAKE_INSTALL_PREFIX}/Module.mk" ROOT_MODULE_MK)
   if(NOT ROOT_MODULE_MK MATCHES "\nMODNAME *:= *vc *\n")
      message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
   endif()
else()
   if(Vc_COMPILER_IS_GCC)
      if(Vc_GCC_VERSION STREQUAL "4.6.0")
         UserWarning("GCC 4.6.0 is broken. The following tests are therefore disabled:
         gather_avx, gather_sse, gather_VC_USE_SET_GATHERS_avx, gather_VC_USE_SET_GATHERS_sse,
         gather_sse_LOOP, scatter_avx, and scatter_sse")
         list(APPEND disabled_targets
            gather_avx
            gather_sse
            gather_VC_USE_SET_GATHERS_avx
            gather_VC_USE_SET_GATHERS_sse
            scatter_avx
            scatter_sse
            c++11_gather_avx
            c++11_gather_sse
            c++11_gather_VC_USE_SET_GATHERS_avx
            c++11_gather_VC_USE_SET_GATHERS_sse
            c++11_scatter_avx
            c++11_scatter_sse
            )
      elseif(Vc_GCC_VERSION STREQUAL "4.5.0" OR Vc_GCC_VERSION STREQUAL "4.5.1")
         UserWarning("GCC 4.5.[12] are known to generate an internal compiler error on the memory unit test.
         (http://gcc.gnu.org/bugzilla/show_bug.cgi?id=46723)
         The test will therefore not be compiled and executed.")
         list(APPEND disabled_targets
            memory_scalar
            memory_sse
            memory_avx
            c++11_memory_scalar
            c++11_memory_sse
            c++11_memory_avx
            )
      elseif(Vc_GCC_VERSION STREQUAL "4.5.2")
         UserWarning("GCC 4.5.2 generates an internal compiler error on the memory_scalar unit test. The test will not be compiled and executed.")
         list(APPEND disabled_targets
            memory_scalar
            c++11_memory_scalar
            )
      endif()
   elseif(Vc_COMPILER_IS_CLANG)
      if(Vc_CLANG_VERSION VERSION_EQUAL "3.0")
         UserWarning("Clang 3.0 generates an internal compiler error on the finitediff example. The example will not be compiled.")
         list(APPEND disabled_targets
            example_finitediff
         )
      endif()
   elseif(Vc_COMPILER_IS_MSVC)
      if(MSVC_VERSION LESS 1700)
         # MSVC before 2012 has a broken std::vector::resize implementation. STL + Vc code will probably not compile.
         # UserWarning in VcMacros.cmake
         list(APPEND disabled_targets
            stlcontainer_sse
            stlcontainer_avx
            c++11_stlcontainer_sse
            c++11_stlcontainer_avx
            )
      endif()
   endif()
endif()

if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebug RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

vc_set_preferred_compiler_flags(WARNING_FLAGS BUILDTYPE_FLAGS)
add_definitions("${Vc_DEFINITIONS}")

if(Vc_COMPILER_IS_INTEL)
   # per default icc is not IEEE compliant, but we need that for verification
   set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -w1 -fp-model precise")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w1 -fp-model precise")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "" AND NOT CMAKE_CXX_FLAGS MATCHES "-O[123]")
   message(STATUS "WARNING! It seems you are compiling without optimization. Please set CMAKE_BUILD_TYPE.")
endif(CMAKE_BUILD_TYPE STREQUAL "" AND NOT CMAKE_CXX_FLAGS MATCHES "-O[123]")

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)

add_custom_target(other VERBATIM)
add_custom_target(Scalar COMMENT "build Scalar code" VERBATIM)
add_custom_target(SSE COMMENT "build SSE code" VERBATIM)
add_custom_target(AVX COMMENT "build AVX code" VERBATIM)

if(NOT ROOT_RELEASE)
   set(libvc_compile_flags "-DVC_COMPILE_LIB")
   AddCompilerFlag("-fPIC" CXX_FLAGS libvc_compile_flags)
   vc_compile_for_all_implementations(_objs src/trigonometric.cpp FLAGS ${libvc_compile_flags}
      ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4)
   # add AVX+XOP+FMA AVX+FMA once there's a check in place whether the assembler can handle FMA instructions
   set(_srcs src/const.cpp src/cpuid.cpp src/support.cpp ${_objs})
   if(USE_AVX)
      list(APPEND _srcs src/avx_sorthelper.cpp)
   else()
      if(NOT Vc_AVX_INTRINSICS_BROKEN)
         # we'd still like to have avx_sorthelper.cpp built in, but that requires compilation with -mavx (or a comparable flag)
         foreach(_flag "-xAVX" "-mavx" "-arch:AVX")
            check_cxx_compiler_flag("${_flag}" check_cxx_compiler_flag_${_flag})
            if(check_cxx_compiler_flag_${_flag})
               if(_flag STREQUAL "-xAVX")
                  set(_flag "${_flag} -diag-disable 10121") # disable the warning "overriding -xSSE4.2 with -xAVX"
               endif()
               list(APPEND _srcs src/avx_sorthelper.cpp)
               set_source_files_properties(src/avx_sorthelper.cpp PROPERTIES COMPILE_FLAGS "${_flag}")
               break()
            endif()
         endforeach()
      endif()
   endif()
   add_library(Vc STATIC ${_srcs})
   add_target_property(Vc COMPILE_FLAGS ${libvc_compile_flags})
   add_target_property(Vc LABELS "other")
   add_dependencies(other Vc)

   install(TARGETS Vc DESTINATION lib/)
else()
   # libVc should be compiled in the AliRoot tree, so we need to install the sources
   #
   # Sadly there are messed up systems where putting include/Vc in the include paths will
   # break the standard library (e.g. MacOS X Lion with case insensitive filesystem).
   # Thus, we modify the includes such that include/Vc never needs to be in the path.
   file(GLOB _srcs RELATIVE "${CMAKE_SOURCE_DIR}" src/*.cpp tests/*.cpp tests/*.h)
   foreach(_src ${_srcs})
      message(STATUS "Processing ${CMAKE_SOURCE_DIR}/${_src} -> ${CMAKE_BINARY_DIR}/${_src}")
      get_filename_component(_path "${CMAKE_BINARY_DIR}/${_src}" PATH)
      file(MAKE_DIRECTORY "${_path}")
      execute_process(
         COMMAND sed "s,#include \\(.\\)\\(common\\|avx\\|sse\\|scalar\\)/,#include \\1Vc/\\2/,"
         INPUT_FILE ${CMAKE_SOURCE_DIR}/${_src}
         OUTPUT_FILE ${CMAKE_BINARY_DIR}/${_src}
         )
   endforeach()
   install(DIRECTORY ${CMAKE_BINARY_DIR}/src/ DESTINATION src)
endif()

install(DIRECTORY include/Vc/ DESTINATION include/Vc)
install(DIRECTORY scalar sse avx common DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")

# read version parts from version.h to be put into VcConfig.cmake
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/Vc/version.h _version_lines REGEX "^#define VC_VERSION_STRING ")
string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" _version_matches "${_version_lines}")
set(Vc_VERSION_MAJOR ${CMAKE_MATCH_1})
set(Vc_VERSION_MINOR ${CMAKE_MATCH_2})
set(Vc_VERSION_PATCH ${CMAKE_MATCH_3})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/VcConfig.cmake.in
   ${CMAKE_CURRENT_BINARY_DIR}/cmake/VcConfig.cmake @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/VcConfigVersion.cmake.in
   ${CMAKE_CURRENT_BINARY_DIR}/cmake/VcConfigVersion.cmake @ONLY)

set(cmake_install_files
   cmake/UserWarning.cmake
   cmake/VcMacros.cmake
   cmake/AddCompilerFlag.cmake
   cmake/CheckCCompilerFlag.cmake
   cmake/CheckCXXCompilerFlag.cmake
   )
if(ROOT_RELEASE)
   execute_process(
      COMMAND sed "s, \"auto\" CACHE, \"none\" CACHE,"
      INPUT_FILE ${CMAKE_SOURCE_DIR}/cmake/OptimizeForArchitecture.cmake
      OUTPUT_FILE ${CMAKE_BINARY_DIR}/cmake/OptimizeForArchitecture.cmake
      )
   install(FILES
      ${cmake_install_files}
      cmake/AddTargetProperty.cmake
      ${CMAKE_BINARY_DIR}/cmake/OptimizeForArchitecture.cmake
      DESTINATION cmake
      )
   install(DIRECTORY examples/ DESTINATION examples)
   install(DIRECTORY ${CMAKE_BINARY_DIR}/tests/ DESTINATION tests)
   install(FILES tests/CMakeLists.txt tests/download.cmake DESTINATION tests)
else()
   install(FILES
      ${cmake_install_files}
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/VcConfig.cmake
      ${CMAKE_CURRENT_BINARY_DIR}/cmake/VcConfigVersion.cmake
      cmake/OptimizeForArchitecture.cmake
      cmake/FindVc.cmake
      DESTINATION lib/cmake/Vc
      )
endif()

if(NOT ROOT_RELEASE)
   include (CTest)
   configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake COPYONLY)
   if(BUILD_TESTING)
      add_subdirectory(tests)
   endif(BUILD_TESTING)

   set(BUILD_EXAMPLES FALSE CACHE BOOL "Build examples.")
   if(BUILD_EXAMPLES)
      add_subdirectory(examples)
   endif(BUILD_EXAMPLES)
endif()

# Hide VC_IMPL as it is only meant for users of Vc
mark_as_advanced(VC_IMPL)

=== tests/CMakeLists.txt ===
include(AddFileDependencies)

add_definitions(-DCOMPILE_FOR_UNIT_TESTS -DVC_CHECK_ALIGNMENT)
if(Vc_COMPILER_IS_MSVC)
   AddCompilerFlag("/wd4267") # Disable warning "conversion from 'size_t' to 'int', possible loss of data"
   AddCompilerFlag("/wd4723") # Disable warning "potential divide by 0" (suppress doesn't work)
endif()

set(CXX11_FLAG)
set(_cxx11_flags "-std=c++11" "-std=c++0x")
if(Vc_COMPILER_IS_GCC AND WIN32)
   # MinGW fails to compile POSIX code unless gnu++11 is used
   set(_cxx11_flags "-std=gnu++11" "-std=gnu++0x")
endif()
foreach(_flag ${_cxx11_flags})
   string(REGEX REPLACE "[-+/:= ]" "_" _flag_esc "${_flag}")
   check_cxx_compiler_flag("${_flag}" check_cxx_compiler_flag_${_flag_esc})
   if(check_cxx_compiler_flag_${_flag_esc})
      set(CXX11_FLAG ${_flag})
      break()
   endif()
endforeach()

macro(vc_add_run_target _target)
   add_custom_target(run_${_target}
      ${_target}
      DEPENDS ${_target}
      COMMENT "Execute ${_target} test"
      VERBATIM
      )
endmacro()

macro(vc_add_test _name)
   foreach(_std cxx98 cxx11)
      set(_extra_flags)
      set(name ${_name})
      foreach(_arg ${ARGN})
         set(_extra_flags "${_extra_flags} -D${_arg}")
         set(name "${name}_${_arg}")
      endforeach()

      if("${_std}" STREQUAL "cxx11")
         if(NOT CXX11_FLAG)
            break()
         endif()
         set(SAVE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
         if(CMAKE_CXX_FLAGS MATCHES " -ansi ")
            string(REPLACE " -ansi " " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
         endif()
         set(_extra_flags "${_extra_flags} ${CXX11_FLAG}")
         set(name "c++11_${name}")
      endif()

      set(_target "${name}_scalar")
      list(FIND disabled_targets ${_target} _disabled)
      if(_disabled EQUAL -1)
         file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/scalar/*.tcc" "${CMAKE_SOURCE_DIR}/scalar/*.h" "${CMAKE_SOURCE_DIR}/common/*.h")
         add_file_dependencies(${_name}.cpp "${_extra_deps}")
         add_executable(${_target} ${_name}.cpp)
         target_link_libraries(${_target} Vc)
         add_target_property(${_target} COMPILE_FLAGS "-DVC_IMPL=Scalar ${_extra_flags}")
         add_target_property(${_target} LABELS "Scalar")
         add_dependencies(Scalar ${_target})
         add_test(${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
         set_property(TEST ${_target} PROPERTY LABELS "Scalar")
         vc_add_run_target(${_target})
      endif()

      if(USE_SSE2 AND NOT Vc_SSE_INTRINSICS_BROKEN)
         set(_target "${name}_sse")
         list(FIND disabled_targets ${_target} _disabled)
         if(_disabled EQUAL -1)
            file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/sse/*.tcc" "${CMAKE_SOURCE_DIR}/sse/*.h" "${CMAKE_SOURCE_DIR}/common/*.h")
            add_file_dependencies(${_name}.cpp "${_extra_deps}")
            add_executable(${_target} ${_name}.cpp)
            target_link_libraries(${_target} Vc)
            add_target_property(${_target} COMPILE_FLAGS "-DVC_IMPL=SSE ${_extra_flags}")
            add_target_property(${_target} LABELS "SSE")
            add_dependencies(SSE ${_target})
            add_test(${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
            set_property(TEST ${_target} PROPERTY LABELS "SSE")
            vc_add_run_target(${_target})
         endif()
      endif()

      if(USE_AVX)
         set(DVC_IMPL "-DVC_IMPL=AVX")
         if(USE_XOP)
            set(DVC_IMPL "${DVC_IMPL}+XOP")
         endif()
         if(USE_FMA4)
            set(DVC_IMPL "${DVC_IMPL}+FMA4")
         endif()
         set(_target "${name}_avx")
         list(FIND disabled_targets ${_target} _disabled)
         if(_disabled EQUAL -1)
            file(GLOB _extra_deps "${CMAKE_SOURCE_DIR}/avx/*.tcc" "${CMAKE_SOURCE_DIR}/avx/*.h" "${CMAKE_SOURCE_DIR}/common/*.h")
            add_file_dependencies(${_name}.cpp "${_extra_deps}")
            add_executable(${_target} ${_name}.cpp)
            target_link_libraries(${_target} Vc)
            add_target_property(${_target} COMPILE_FLAGS "${DVC_IMPL} ${_extra_flags}")
            add_target_property(${_target} LABELS "AVX")
            add_dependencies(AVX ${_target})
            add_test(${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
            set_property(TEST ${_target} PROPERTY LABELS "AVX")
            vc_add_run_target(${_target})
         endif()
      endif(USE_AVX)
      if("${_std}" STREQUAL "cxx11")
         set(CMAKE_CXX_FLAGS "${SAVE_CXX_FLAGS}")
      endif()
   endforeach()
endmacro(vc_add_test)

vc_add_test(stlcontainer)
vc_add_test(scalaraccess)
vc_add_test(memory)
vc_add_test(arithmetics)
vc_add_test(implicit_type_conversion)
vc_add_test(expandandmerge)
vc_add_test(load)
vc_add_test(store)
vc_add_test(gather)
vc_add_test(gather VC_USE_BSF_GATHERS)
vc_add_test(gather VC_USE_POPCNT_BSF_GATHERS)
vc_add_test(gather VC_USE_SET_GATHERS)
vc_add_test(scatter)
vc_add_test(scatter VC_USE_BSF_SCATTERS)
vc_add_test(scatter VC_USE_POPCNT_BSF_SCATTERS)
vc_add_test(math)
vc_add_test(math VC_LOG_ILP)
vc_add_test(math VC_LOG_ILP2)
vc_add_test(mask)
vc_add_test(utils)
vc_add_test(deinterleave)
vc_add_test(deinterleave VC_USE_MASKMOV_SCATTER)
vc_add_test(casts)
vc_add_test(swizzles)

if(USE_SSE2 AND NOT Vc_SSE_INTRINSICS_BROKEN)
   list(FIND disabled_targets sse_blend _disabled)
   if(_disabled EQUAL -1)
      add_executable(sse2_blend sse_blend.cpp)
      add_target_property(sse2_blend COMPILE_FLAGS "-DVC_IMPL=SSE2")
      add_target_property(sse2_blend LABELS "SSE")
      add_dependencies(SSE sse2_blend)
      add_test(sse2_blend "${CMAKE_CURRENT_BINARY_DIR}/sse2_blend")
      set_property(TEST sse2_blend PROPERTY LABELS "SSE")
      target_link_libraries(sse2_blend Vc)

      if(USE_SSE4_1)
         add_executable(sse4_blend sse_blend.cpp)
         add_target_property(sse4_blend COMPILE_FLAGS "-DVC_IMPL=SSE4_1")
         add_target_property(sse4_blend LABELS "SSE")
         add_dependencies(SSE sse4_blend)
         add_test(sse4_blend "${CMAKE_CURRENT_BINARY_DIR}/sse4_blend")
         set_property(TEST sse4_blend PROPERTY LABELS "SSE")
         target_link_libraries(sse4_blend Vc)
      endif()
   endif()
endif()

add_executable(supportfunctions supportfunctions.cpp)
target_link_libraries(supportfunctions Vc)
add_target_property(supportfunctions LABELS "other")
add_dependencies(other supportfunctions)
add_test(supportfunctions "${CMAKE_CURRENT_BINARY_DIR}/supportfunctions")
set_property(TEST supportfunctions PROPERTY LABELS "other")
vc_add_run_target(supportfunctions)

get_property(_incdirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
set(incdirs)
foreach(_d ${_incdirs})
   list(APPEND incdirs "-I${_d}")
endforeach()

separate_arguments(_flags UNIX_COMMAND ${CMAKE_CXX_FLAGS})
foreach(_f ${_flags})
   if(_f MATCHES "^-m" OR _f MATCHES "^/arch:" OR _f MATCHES "^-x")
      list(REMOVE_ITEM _flags "${_f}")
   endif()
endforeach()

set(TEST_OPERATOR_FAILURES FALSE CACHE BOOL "Run implicit type conversion operator tests.")
if(TEST_OPERATOR_FAILURES)
   macro(vc_test_implicit_type_conversion_failures A B)
      foreach(impl Scalar SSE AVX)
         if("${impl}" STREQUAL "Scalar")
            set(_implFlags)
         elseif("${impl}" STREQUAL "SSE")
            if(Vc_COMPILER_IS_MSVC)
               AddCompilerFlag("/arch:SSE2" CXX_FLAGS _implFlags)
               string(STRIP "${_implFlags}" _implFlags)
            elseif(Vc_COMPILER_IS_INTEL)
               set(_implFlags "-xSSE2")
            else()
               set(_implFlags "-msse2")
            endif()
         elseif("${impl}" STREQUAL "AVX")
            if(Vc_AVX_INTRINSICS_BROKEN)
               break()
            endif()
            if(Vc_COMPILER_IS_MSVC)
               set(_implFlags "/arch:AVX")
            elseif(Vc_COMPILER_IS_INTEL)
               set(_implFlags "-xAVX")
            else()
               set(_implFlags "-mavx")
            endif()
         endif()
         set(type_b ${B})
         foreach(type_a ${A} ${B})
            foreach(op "^" "==" "*") # "/" "+" "-" "&" "|" "!=" "<=" ">=" "<" ">")
               set(name "implicit_type_conversion_failures_${type_a}_${op}_${type_b}_${impl}")
               add_test(NAME "${name}" WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                  COMMAND
                  ${CMAKE_CXX_COMPILER} ${_flags} ${_implFlags}
                  ${incdirs} -o "${name}.tmp"
                  "-DTYPE_A=${type_a}" "-DTEST_OP=${op}" "-DTYPE_B=${type_b}" "-DVC_IMPL=${impl}"
                  ${CMAKE_CURRENT_SOURCE_DIR}/implicit_type_conversion_failures.cpp
                  )
               set_property(TEST "${name}" PROPERTY LABELS "${impl}")
               set_tests_properties("${name}" PROPERTIES
                  PASS_REGULAR_EXPRESSION "invalid operands to binary expression;error: no match for .*operator\\${op};error C267[789]: binary .*\\${op}.* no (global )?operator found;error: no operator \"\\${op}\" matches these operands"
                  FAIL_REGULAR_EXPRESSION "no such file or directory;undefined reference to"
                  )
            endforeach()
            set(type_b ${A})
         endforeach()
      endforeach()
   endmacro()
   vc_test_implicit_type_conversion_failures("double_v"    "float_v")
   vc_test_implicit_type_conversion_failures("double_v"    "short_v")
   vc_test_implicit_type_conversion_failures("double_v"   "ushort_v")
   vc_test_implicit_type_conversion_failures("double_v"      "int_v")
   vc_test_implicit_type_conversion_failures("double_v"     "uint_v")
   vc_test_implicit_type_conversion_failures( "float_v"     "double")
   vc_test_implicit_type_conversion_failures( "float_v"    "short_v")
   vc_test_implicit_type_conversion_failures( "float_v"   "ushort_v")
   vc_test_implicit_type_conversion_failures("sfloat_v"   "double_v")
   vc_test_implicit_type_conversion_failures("sfloat_v"     "double")
   vc_test_implicit_type_conversion_failures("sfloat_v"    "float_v")
   vc_test_implicit_type_conversion_failures("sfloat_v"      "int_v")
   vc_test_implicit_type_conversion_failures("sfloat_v"     "uint_v")
   vc_test_implicit_type_conversion_failures( "short_v"      "int_v")
   vc_test_implicit_type_conversion_failures( "short_v"     "uint_v")
   vc_test_implicit_type_conversion_failures("ushort_v"      "int_v")
   vc_test_implicit_type_conversion_failures("ushort_v"     "uint_v")
   vc_test_implicit_type_conversion_failures("double_v"       "bool")
   vc_test_implicit_type_conversion_failures("sfloat_v"       "bool")
   vc_test_implicit_type_conversion_failures( "float_v"       "bool")
   vc_test_implicit_type_conversion_failures(   "int_v"       "bool")
   vc_test_implicit_type_conversion_failures(  "uint_v"       "bool")
   vc_test_implicit_type_conversion_failures( "short_v"       "bool")
   vc_test_implicit_type_conversion_failures("ushort_v"       "bool")
endif()

# compile and link test for targets that need to link lots of stuff together
add_library(linkTestLibDynamic1 SHARED linkTestLib0.cpp linkTestLib1.cpp)
add_library(linkTestLibDynamic2 SHARED linkTestLib0.cpp linkTestLib1.cpp)
add_library(linkTestLibStatic STATIC linkTestLib2.cpp linkTestLib3.cpp)
add_executable(linkTest linkTest0.cpp linkTest1.cpp)
target_link_libraries(linkTestLibDynamic1 Vc)
target_link_libraries(linkTestLibDynamic2 Vc)
add_target_property(linkTestLibDynamic1 COMPILE_FLAGS "-DPOSTFIX=A")
add_target_property(linkTestLibDynamic2 COMPILE_FLAGS "-DPOSTFIX=B")
target_link_libraries(linkTestLibStatic Vc)
target_link_libraries(linkTest Vc linkTestLibDynamic1 linkTestLibDynamic2 linkTestLibStatic)

# Use the following program to generate the sincos-reference-*.dat files
#add_executable(convert-sincos-reference convert-sincos-reference.cpp)

set(_deps)
foreach(fun sincos asin acos atan ln log2 log10)
   foreach(filename reference-${fun}-sp.dat reference-${fun}-dp.dat)
      add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${filename}"

=== debian/changelog ===
vc (0.7.0-0ubuntu3) raring; urgency=low

  * Add kubuntu_01_git.diff to bring up to date with git branch
   - Adds full licence to cmake modules
   - Installs into lib suffix for multiarch
  * Update copyright

 -- Jonathan Riddell <jriddell@ubuntu.com>  Sat, 09 Mar 2013 00:14:57 +0000

vc (0.7.0-0ubuntu2) raring; urgency=low

  * Rename binary to vc-dev, a libvc-dev is already in the archive

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 08 Mar 2013 22:34:36 +0000

vc (0.7.0-0ubuntu1) raring; urgency=low

  * Initial release LP: #1144539

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 08 Mar 2013 12:50:59 +0000

## vc 0.7.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,9 +19,19 @@
 vc_determine_compiler()
 
 if(ROOT_RELEASE)
-   file(READ "${CMAKE_INSTALL_PREFIX}/Module.mk" ROOT_MODULE_MK)
-   if(NOT ROOT_MODULE_MK MATCHES "\nMODNAME *:= *vc *\n")
-      message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
+   if(EXISTS "${CMAKE_INSTALL_PREFIX}/Module.mk")
+      file(READ "${CMAKE_INSTALL_PREFIX}/Module.mk" ROOT_MODULE_MK)
+      if(NOT "${ROOT_MODULE_MK}" MATCHES "\nMODNAME *:= *vc *\n")
+         message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
+      endif()
+      set(_extra_namespace "ROOT")
+   endif()
+   if(EXISTS "${CMAKE_INSTALL_PREFIX}/Vc.cmake")
+      file(READ "${CMAKE_INSTALL_PREFIX}/Vc.cmake" ALIROOT_VC_CMAKE)
+      if(NOT "${ALIROOT_VC_CMAKE}" MATCHES "\nmacro\\(ALICE_UseVc\\)\n")
+         message(FATAL_ERROR "CMAKE_INSTALL_PREFIX is incorrect. It must point to the Vc subdirectory inside ROOT/AliRoot")
+      endif()
+      set(_extra_namespace "AliRoot")
    endif()
 else()
    if(Vc_COMPILER_IS_GCC)
@@ -91,11 +101,14 @@
 
 vc_set_preferred_compiler_flags(WARNING_FLAGS BUILDTYPE_FLAGS)
 add_definitions("${Vc_DEFINITIONS}")
+if(Vc_COMPILER_IS_GCC AND Vc_GCC_VERSION VERSION_LESS 4.3.0)
+   add_definitions(-DVC_DONT_WARN_OLD_GCC) # this warning is only interesting for external users of Vc
+endif()
 
 if(Vc_COMPILER_IS_INTEL)
    # per default icc is not IEEE compliant, but we need that for verification
-   set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -w1 -fp-model precise")
-   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w1 -fp-model precise")
+   set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -fp-model source")
+   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fp-model source")
 endif()
 
 if(CMAKE_BUILD_TYPE STREQUAL "" AND NOT CMAKE_CXX_FLAGS MATCHES "-O[123]")
@@ -104,17 +117,16 @@
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/include)
 
-add_custom_target(other VERBATIM)
-add_custom_target(Scalar COMMENT "build Scalar code" VERBATIM)
-add_custom_target(SSE COMMENT "build SSE code" VERBATIM)
-add_custom_target(AVX COMMENT "build AVX code" VERBATIM)
-
 if(NOT ROOT_RELEASE)
+   add_custom_target(other VERBATIM)
+   add_custom_target(Scalar COMMENT "build Scalar code" VERBATIM)
+   add_custom_target(SSE COMMENT "build SSE code" VERBATIM)
+   add_custom_target(AVX COMMENT "build AVX code" VERBATIM)
+
    set(libvc_compile_flags "-DVC_COMPILE_LIB")
    AddCompilerFlag("-fPIC" CXX_FLAGS libvc_compile_flags)
    vc_compile_for_all_implementations(_objs src/trigonometric.cpp FLAGS ${libvc_compile_flags}
-      ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4)
-   # add AVX+XOP+FMA AVX+FMA once there's a check in place whether the assembler can handle FMA instructions
+      ONLY SSE2 SSE3 SSSE3 SSE4_1 AVX SSE+XOP+FMA4 AVX+XOP+FMA4 AVX+XOP+FMA AVX+FMA)
    set(_srcs src/const.cpp src/cpuid.cpp src/support.cpp ${_objs})
    if(USE_AVX)
       list(APPEND _srcs src/avx_sorthelper.cpp)
@@ -139,9 +151,11 @@
    add_target_property(Vc LABELS "other")
    add_dependencies(other Vc)
 
-   install(TARGETS Vc DESTINATION lib/)
+   install(TARGETS Vc DESTINATION lib${LIB_SUFFIX})
+   install(DIRECTORY include/Vc/ DESTINATION include/Vc)
+   install(DIRECTORY scalar sse avx common DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
 else()
-   # libVc should be compiled in the AliRoot tree, so we need to install the sources
+   # libVc should be compiled in the ROOT/AliRoot tree, so we need to install the sources
    #
    # Sadly there are messed up systems where putting include/Vc in the include paths will
    # break the standard library (e.g. MacOS X Lion with case insensitive filesystem).
@@ -152,16 +166,52 @@
       get_filename_component(_path "${CMAKE_BINARY_DIR}/${_src}" PATH)
       file(MAKE_DIRECTORY "${_path}")
       execute_process(
-         COMMAND sed "s,#include \\(.\\)\\(common\\|avx\\|sse\\|scalar\\)/,#include \\1Vc/\\2/,"
+         COMMAND sed -e "s,#include \\(.\\)\\(common\\|avx\\|sse\\|scalar\\)/,#include \\1Vc/\\2/,"
+                     -e "s,::Vc::,::${_extra_namespace}::Vc::,g"
+                     -e "s,/\\*OUTER_NAMESPACE_BEGIN\\*/,namespace ${_extra_namespace} {,"
+                     -e "s,/\\*OUTER_NAMESPACE_END\\*/,} // namespace ${_extra_namespace},"
+                     -e "s,/\\*NAMESPACE_ALIAS\\*/,namespace Vc = ${_extra_namespace}::Vc;,"
          INPUT_FILE ${CMAKE_SOURCE_DIR}/${_src}
          OUTPUT_FILE ${CMAKE_BINARY_DIR}/${_src}
          )
    endforeach()
    install(DIRECTORY ${CMAKE_BINARY_DIR}/src/ DESTINATION src)
-endif()
-
-install(DIRECTORY include/Vc/ DESTINATION include/Vc)
-install(DIRECTORY scalar sse avx common DESTINATION include/Vc FILES_MATCHING REGEX "/*.(h|tcc|def)$")
+
+   set(includes)
+   macro(copy_and_set_outer_namespace dst)
+      foreach(_name ${ARGN})
+         set(_dst "${dst}${_name}")
+         set(_src "${CMAKE_SOURCE_DIR}/${_name}")
+         get_filename_component(_dir "${_dst}" PATH)
+         add_custom_command(OUTPUT "${_dst}"
+            COMMAND mkdir -p "${_dir}"
+            COMMAND cp  "${_src}" "${_dst}"
+            COMMAND sed -e "s,::Vc::,::${_extra_namespace}::Vc::,g"
+                        -e "s,/\\*OUTER_NAMESPACE_BEGIN\\*/,namespace ${_extra_namespace} {,"
+                        -e "s,/\\*OUTER_NAMESPACE_END\\*/,} // namespace ${_extra_namespace},"
+                        -e "s,/\\*NAMESPACE_ALIAS\\*/,namespace Vc = ${_extra_namespace}::Vc;,"
+                        -i "${_dst}"
+            MAIN_DEPENDENCY "${_src}"
+            COMMENT "Rewrite ${_dst}"
+            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
+            VERBATIM)
+         list(APPEND includes "${_dst}")
+      endforeach()
+   endmacro()
+
+   file(GLOB_RECURSE _srcs RELATIVE "${CMAKE_SOURCE_DIR}" include/*.h include/*.tcc include/*.def)
+   file(GLOB _src2 RELATIVE "${CMAKE_SOURCE_DIR}" include/Vc/*)
+   list(APPEND _srcs ${_src2})
+   list(REMOVE_DUPLICATES _srcs)
+   copy_and_set_outer_namespace("" "${_srcs}")
+
+   foreach(_dir in scalar sse avx common)
+      file(GLOB_RECURSE _srcs RELATIVE "${CMAKE_SOURCE_DIR}" ${_dir}/*.h ${_dir}/*.tcc ${_dir}/*.def)
+      copy_and_set_outer_namespace("include/Vc/" "${_srcs}")
+   endforeach()
+   add_custom_target(rewrite ALL DEPENDS ${includes})
+   install(DIRECTORY ${CMAKE_BINARY_DIR}/include/Vc/ DESTINATION include/Vc)
+endif()
 
 # read version parts from version.h to be put into VcConfig.cmake
 file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/Vc/version.h _version_lines REGEX "^#define VC_VERSION_STRING ")

=== examples/CMakeLists.txt ===
find_package(Qt4)
set(SAFE_CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES}")
set(SAFE_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
set(CMAKE_REQUIRED_INCLUDES "${QT_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${QT_QTCORE_LIBRARY}")
CHECK_CXX_SOURCE_COMPILES("#include <QObject>
int main() { QObject o; return 0;}" QT4_USABLE)
mark_as_advanced(QT4_USABLE)
set(CMAKE_REQUIRED_INCLUDES "${SAFE_CMAKE_REQUIRED_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${SAFE_CMAKE_REQUIRED_LIBRARIES}")

macro(build_example name)
   set(_SRCS)
   set(_LIBS)
   set(_state 1)
   foreach(ARG ${ARGN})
      if(ARG STREQUAL "LIBS")
         set(_state 2)
      elseif(_state EQUAL 1)
         set(_SRCS ${_SRCS} ${ARG})
      elseif(_state EQUAL 2)
         set(_LIBS ${_LIBS} ${ARG})
      endif()
   endforeach()
   add_executable("example_${name}_default" ${_SRCS})
   target_link_libraries("example_${name}_default" Vc ${_LIBS})

   add_executable("example_${name}_scalar" ${_SRCS})
   add_target_property("example_${name}_scalar" COMPILE_FLAGS "-DVC_IMPL=Scalar")
   add_target_property("example_${name}_scalar" LABELS "Scalar")
   add_dependencies(Scalar "example_${name}_scalar")
   target_link_libraries("example_${name}_scalar" Vc ${_LIBS})

   if(USE_SSE2)
      add_executable("example_${name}_sse" ${_SRCS})
      add_target_property("example_${name}_sse" COMPILE_FLAGS "-DVC_IMPL=SSE")
      add_target_property("example_${name}_sse" LABELS "SSE")
      add_dependencies(SSE "example_${name}_sse")
      target_link_libraries("example_${name}_sse" Vc ${_LIBS})
   endif()

   if(USE_AVX)
      add_executable("example_${name}_avx" ${_SRCS})
      add_target_property("example_${name}_avx" COMPILE_FLAGS "-DVC_IMPL=AVX")
      add_target_property("example_${name}_avx" LABELS "AVX")
      add_dependencies(AVX "example_${name}_avx")
      target_link_libraries("example_${name}_avx" Vc ${_LIBS})

      add_target_property("example_${name}_default" LABELS "AVX")
      add_dependencies(AVX "example_${name}_default")
   elseif(USE_SSE2)
      add_target_property("example_${name}_default" LABELS "SSE")
      add_dependencies(SSE "example_${name}_default")
   else()
      add_target_property("example_${name}_default" LABELS "Scalar")
      add_dependencies(Scalar "example_${name}_default")
   endif()
endmacro(build_example)

macro(my_add_subdirectory _name)
   list(FIND disabled_targets "example_${_name}" _disabled)
   if(_disabled EQUAL -1)
      add_subdirectory(${_name})
   endif()
endmacro()

my_add_subdirectory(polarcoord)
my_add_subdirectory(matrix)
my_add_subdirectory(mandelbrot)
my_add_subdirectory(buddhabrot)
my_add_subdirectory(finitediff)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include(AddFileDependencies)
 
-add_definitions(-DCOMPILE_FOR_UNIT_TESTS -DVC_CHECK_ALIGNMENT)
+add_definitions(-DCOMPILE_FOR_UNIT_TESTS) # -DVC_CHECK_ALIGNMENT)
 if(Vc_COMPILER_IS_MSVC)
    AddCompilerFlag("/wd4267") # Disable warning "conversion from 'size_t' to 'int', possible loss of data"
    AddCompilerFlag("/wd4723") # Disable warning "potential divide by 0" (suppress doesn't work)
@@ -67,6 +67,15 @@
       endif()
 
       if(USE_SSE2 AND NOT Vc_SSE_INTRINSICS_BROKEN)
+         set(DVC_IMPL "-DVC_IMPL=SSE")
+         if(USE_XOP)
+            set(DVC_IMPL "${DVC_IMPL}+XOP")
+         endif()
+         if(USE_FMA)
+            set(DVC_IMPL "${DVC_IMPL}+FMA")
+         elseif(USE_FMA4)
+            set(DVC_IMPL "${DVC_IMPL}+FMA4")
+         endif()
          set(_target "${name}_sse")
          list(FIND disabled_targets ${_target} _disabled)
          if(_disabled EQUAL -1)
@@ -74,7 +83,7 @@
             add_file_dependencies(${_name}.cpp "${_extra_deps}")
             add_executable(${_target} ${_name}.cpp)
             target_link_libraries(${_target} Vc)
-            add_target_property(${_target} COMPILE_FLAGS "-DVC_IMPL=SSE ${_extra_flags}")
+            add_target_property(${_target} COMPILE_FLAGS "${DVC_IMPL} ${_extra_flags}")
             add_target_property(${_target} LABELS "SSE")
             add_dependencies(SSE ${_target})
             add_test(${_target} "${CMAKE_CURRENT_BINARY_DIR}/${_target}")
@@ -88,7 +97,9 @@
          if(USE_XOP)
             set(DVC_IMPL "${DVC_IMPL}+XOP")
          endif()
-         if(USE_FMA4)
+         if(USE_FMA)
+            set(DVC_IMPL "${DVC_IMPL}+FMA")
+         elseif(USE_FMA4)
             set(DVC_IMPL "${DVC_IMPL}+FMA4")
          endif()
          set(_target "${name}_avx")
@@ -268,9 +279,3 @@
 target_link_libraries(linkTest Vc linkTestLibDynamic1 linkTestLibDynamic2 linkTestLibStatic)
 
 # Use the following program to generate the sincos-reference-*.dat files
-#add_executable(convert-sincos-reference convert-sincos-reference.cpp)
-
-set(_deps)
-foreach(fun sincos asin acos atan ln log2 log10)
-   foreach(filename reference-${fun}-sp.dat reference-${fun}-dp.dat)
-      add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${filename}"

=== debian/changelog ===
vc (0.7.3-0ubuntu1) saucy; urgency=low

  * New upstream release (LP: #1223876) 

 -- Howard Chan <smartboyhw@gmail.com>  Wed, 11 Sep 2013 20:44:19 +0800

vc (0.7.2-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 07 Jun 2013 16:39:44 +0100

=== debian/control ===
Source: vc
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Jonathan Riddell <jriddell@ubuntu.com>
Build-Depends: debhelper (>= 8.0.0), cmake
Standards-Version: 3.9.4
Section: libs
Homepage: http://code.compeng.uni-frankfurt.de/projects/vc

Package: vc-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to ease explicit vectorization of C++ code
 Vc is a free software library to ease explicit vectorization of C++
 code. It has an intuitive API and provides portability between
 different compilers and compiler versions as well as portability
 between different vector instruction sets. Thus an application
 written with Vc can be compiled for
  - AVX
  - SSE2 up to SSE4.2
  - SSE4a, XOP, and FMA4
  - Scalar (fallback which works everywhere)
  - LRBni support disabled, waiting for MIC
